Unit afp4e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure afp4e(var A :Array of Extended; N :Integer; M :Integer;
                var D1 :Array of Extended; var D2 :Array of Extended);

implementation

procedure afp4e(var A :Array of Extended; N :Integer; M :Integer;
                var D1 :Array of Extended; var D2 :Array of Extended);
var
I,J,B,C :Integer;
D,E,H,K,P,W,BC,BM,BO,BY :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30;
begin
for B:=1 to M do
 begin
  if ( B <> N ) 
   then goto _1;
  D1[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := 0.e0;
  goto _30;
_1:
  for I:=B to N do
   begin
    D1[I-1] := A[(I-1)+(B-1)*N];
_2:
   end;
  E := 0.e0;
  for I:=B to N do
   begin
    BC := Abs(D1[I-1]);
    if ( E >= BC ) 
     then goto _3;
    E := BC;
_3:
   end;
  if ( E <> 0.e0 ) 
   then goto _4;
  C := B+1;
  goto _15;
_4:
  P := 1.e0/E;
  H := 0.e0;
  for I:=B to N do
   begin
    H := H+D1[I-1]*P*D1[I-1]*P;
_5:
   end;
  E := Sqrt(H)*E;
  H := 1.e0/E;
  for I:=B to N do
   begin
    D1[I-1] := D1[I-1]*H;
_6:
   end;
  if ( D1[B-1] <> 0.e0 ) 
   then goto _7;
  D1[B-1] := 1.e0;
  D := -E;
  goto _9;
_7:
  D := Sign(1.e0,D1[B-1]);
  H := 1.e0+Abs(D1[B-1]);
  D1[B-1] := D*H;
  H := 1.e0/Sqrt(H);
  for I:=B to N do
   begin
    D1[I-1] := D1[I-1]*H;
_8:
   end;
  D := -E*D;
_9:
  for I:=B to N do
   begin
    A[(I-1)+(B-1)*N] := D1[I-1];
_10:
   end;
  if ( B <> M ) 
   then goto _11;
  D1[B-1] := D;
  goto _30;
_11:
  C := B+1;
  for J:=C to M do
   begin
    BM := 0.e0;
    for I:=B to N do
     begin
      BM := BM+A[(I-1)+(J-1)*N]*D1[I-1];
_12:
     end;
    for I:=B to N do
     begin
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-BM*D1[I-1];
_13:
     end;
_14:
   end;
  D1[B-1] := D;
_15:
  if ( C <> M ) 
   then goto _16;
  D2[B-1] := A[(B-1)+(C-1)*N];
  A[(B-1)+(C-1)*N] := 0.e0;
  goto _29;
_16:
  for J:=C to M do
   begin
    D2[J-1] := A[(B-1)+(J-1)*N];
_17:
   end;
  E := 0.e0;
  for J:=C to M do
   begin
    BO := Abs(D2[J-1]);
    if ( E >= BO ) 
     then goto _18;
    E := BO;
_18:
   end;
  if ( E <> 0.e0 ) 
   then goto _19;
  D2[B-1] := 0.e0;
  goto _29;
_19:
  W := 1.e0/E;
  K := 0.e0;
  for J:=C to M do
   begin
    K := K+D2[J-1]*W*D2[J-1]*W;
_20:
   end;
  E := Sqrt(K)*E;
  K := 1.e0/E;
  for J:=C to M do
   begin
    D2[J-1] := D2[J-1]*K;
_21:
   end;
  if ( D2[C-1] <> 0.e0 ) 
   then goto _22;
  D2[C-1] := 1.e0;
  D := -E;
  goto _24;
_22:
  D := Sign(1.e0,D2[C-1]);
  K := 1.e0+Abs(D2[C-1]);
  D2[C-1] := D*K;
  K := 1.e0/Sqrt(K);
  for J:=C to M do
   begin
    D2[J-1] := D2[J-1]*K;
_23:
   end;
  D := -E*D;
_24:
  for J:=C to M do
   begin
    A[(B-1)+(J-1)*N] := D2[J-1];
_25:
   end;
  for I:=C to N do
   begin
    BY := 0.e0;
    for J:=C to M do
     begin
      BY := BY+A[(I-1)+(J-1)*N]*D2[J-1];
_26:
     end;
    for J:=C to M do
     begin
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-BY*D2[J-1];
_27:
     end;
_28:
   end;
  D2[B-1] := D;
_29:
 end;
_30:
end;

end.
